#!/usr/bin/python
# -*- coding: utf-8 -*-

#Copyright 2009 tv-player team <tvplayer.staff@gmail.com>
#       
#This program is free software; you can redistribute it and/or modify
#it under the terms of the GNU Lesser General Public License as published by
#the Free Software Foundation; version 3 of the License.
#       
#This program is distributed in the hope that it will be useful,
#but WITHOUT ANY WARRANTY; without even the implied warranty of
#MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#GNU Lesser General Public License for more details.
#       
#You should have received a copy of the GNU Lesser General Public License
#along with this program; if not, write to the Free Software
#Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston,
#MA 02110-1301, USA.

import os, sys

# This module is used to import "STUFF_DIR" - the path to data files.

########################## CONFIGURATION #######################################

# The assumption is that if a folder contains "regioni.list", _that_ is the folder to search files in.

script_path = os.path.realpath( os.path.join( sys.path[0], sys.argv[0] ) )


not_installed_dir = os.path.dirname( script_path )

if os.path.exists( os.path.join(not_installed_dir, 'regioni.list') ):
    STUFF_DIR = not_installed_dir
    LOCALE_DIR = os.path.join( not_installed_dir, '/locale' )
else:
    for directory in [sys.prefix, sys.prefix + 'local']:
        installed_root_dir = os.path.join( directory, 'share' )
        if os.path.exists( os.path.join( installed_root_dir,  'tvplayer', 'regioni.list' ) ):
            STUFF_DIR = os.path.join( installed_root_dir, 'tvplayer' )
            LOCALE_DIR = os.path.join( installed_root_dir, 'locale' )
            break
        else:
            print os.path.join( installed_root_dir,  'tvplayer', 'regioni.list' )

########################## END OF CONFIGURATION ################################

########################## LOCALIZATION ########################################

import locale
import gettext

APP = 'tvplayer'

gettext.install(APP, localedir=LOCALE_DIR, unicode=True)

# For gtk.Builders:
locale.bindtextdomain(APP, LOCALE_DIR)

########################## END OF LOCALIZATION #################################

