# -*- coding: utf-8 -*-

#Copyright 2009 tv-player team <tvplayer.staff@gmail.com>
#       
#This program is free software; you can redistribute it and/or modify
#it under the terms of the GNU Lesser General Public License as published by
#the Free Software Foundation; version 3 of the License.
#       
#This program is distributed in the hope that it will be useful,
#but WITHOUT ANY WARRANTY; without even the implied warranty of
#MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#GNU Lesser General Public License for more details.
#       
#You should have received a copy of the GNU Lesser General Public License
#along with this program; if not, write to the Free Software
#Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston,
#MA 02110-1301, USA.

import urllib
from xml.dom import minidom
import string
import gtk
import threading

import gdata.youtube
import gdata.youtube.service
import urllib2
import re

import datetime
import os

import player

import gettext

_ = gettext.gettext

class ThreadXML(threading.Thread):
    def __init__(self, model, statusbar, combobox):
        threading.Thread.__init__(self)
        self.model = model
        self.statusbar = statusbar
        self.combobox = combobox
        self.combobox.set_button_sensitivity(gtk.SENSITIVITY_OFF)

    def run(self):
		
        home = os.path.expanduser('~')
        self.config_dir = home +'/.tvplayer'
        import rai_XML
        gtk.gdk.threads_enter()
        self.model.clear()
        self.file = open(self.config_dir +'/RAI_xml.list', 'r')
        for i in range (30):
            self.file.readline()
        for line in self.file.readlines() :
            temp = line.split('~')
            self.model.append([temp[0],temp[1][:-1]])
        self.file.close()
        
        self.statusbar.push(1,_("Rai's recordings list updated"))
        self.combobox.set_button_sensitivity(gtk.SENSITIVITY_ON)
        gtk.gdk.threads_leave()
       
class ThreadXML_la7(threading.Thread):
    def __init__(self, model, statusbar, combobox):
        threading.Thread.__init__(self)
        self.model = model
        self.statusbar = statusbar
        self.combobox = combobox
        self.combobox.set_button_sensitivity(gtk.SENSITIVITY_OFF)

    def run(self):
        home = os.path.expanduser('~')
        self.config_dir = home +'/.tvplayer/la7image'
        
        self.now=datetime.date.today()
        self.rtmpurl="rtmp://yalpvod.alice.cdn.interbusiness.it:1935/vod"
		#http://www.la7.tv/xml/cult/index.xml

        self.webXMLfile = urllib.urlopen("http://www.la7.tv/xml/epg/index.xml")
       # a=self.webXMLfile.read()
       # a.replace('&','E')
       # f=open(home +"/.tvplayer/la7.xml","w")
       # f.write(a)
       # f.close
        
        self.xmldoc = minidom.parse(self.webXMLfile)

        self.webXMLfile.close()

        self.showlist = self.xmldoc.getElementsByTagName('show')

        self.cont=1


        gtk.gdk.threads_enter()
        self.model.clear()

        for i in self.showlist:
            self.itemlist = i.getElementsByTagName("item")
            self.logo = i.getElementsByTagName("logo")
            self.urlimage = self.logo[0].attributes["src"].value
			#print self.urlimage
			
            self.imagefile = urllib.urlopen(self.urlimage)
            self.localFile = open(os.path.expanduser(self.config_dir + '/'+str(self.cont)+'.jpg'), 'w+')
            self.localFile.write(self.imagefile.read())
            self.imagefile.close()
            self.localFile.close()
            
            self.image = gtk.gdk.pixbuf_new_from_file(self.config_dir + '/'+str(self.cont)+'.jpg')
			
            for j in self.itemlist:
                self.titlelist = j.getElementsByTagName("title")
				#print titlelist
                self.titolo = self.titlelist[0].toxml()[7:-8]
				#url = j.attributes["linkUrl"].value
				#print url
                self.xmlurl = j.attributes["xmlURL"].value

                self.webXMLfile = urllib.urlopen(self.xmlurl)
   
                self.xmldoc2 = minidom.parse(self.webXMLfile)

                self.webXMLfile.close()
                self.description = self.xmldoc2.getElementsByTagName('description')
                self.descrizione = self.description[0].toxml()[13:-14]
				
                self.fms = self.xmldoc2.getElementsByTagName('fms')
               # print self.rtmpurl+self.fms[1].toxml()[9:-6]


                self.diff = datetime.timedelta(days=int(j.attributes["pos"].value)-6)
                self.data = self.now+self.diff
                self.model.append([self.image,"<b>"+self.titolo.encode("UTF-8")+"</b>\n<i>"+self.descrizione.encode("UTF-8")+"</i>\n<span foreground='blue'><small>DATA: "+str(self.data)+"</small></span>",self.rtmpurl+self.fms[1].toxml()[9:-6]])
                gtk.gdk.threads_leave()
            self.cont+=1
        self.combobox.set_button_sensitivity(gtk.SENSITIVITY_ON)
        self.statusbar.push(1,_("La7's recordings list: 'The Week' updated"))
            
            
class ThreadXML_la7Cult(threading.Thread):
    def __init__(self, model, statusbar, combobox):
        threading.Thread.__init__(self)
        self.model = model
        self.statusbar = statusbar
        self.combobox = combobox
        self.combobox.set_button_sensitivity(gtk.SENSITIVITY_OFF)

    def run(self):
        self.rtmpurl="rtmp://yalpvod.alice.cdn.interbusiness.it:1935/vod"

        self.webXMLfile = urllib.urlopen("http://www.la7.tv/xml/cult/index.xml")

        self.xmldoc = minidom.parse(self.webXMLfile)

        self.webXMLfile.close()

        self.showlist = self.xmldoc.getElementsByTagName('show')

        self.cont=1
        home = os.path.expanduser('~')
        self.config_dir = home +'/.tvplayer/la7image/cult'

        gtk.gdk.threads_enter()
        self.model.clear()

        for i in self.showlist:
            self.itemlist = i.getElementsByTagName("item")
            self.logo = i.getElementsByTagName("logo")
            self.urlimage = self.logo[0].attributes["src"].value
			#print self.urlimage
			
            self.imagefile = urllib.urlopen(self.urlimage)
            self.localFile = open(os.path.expanduser(self.config_dir + '/'+str(self.cont)+'.jpg'), 'w+')
            self.localFile.write(self.imagefile.read())
            self.imagefile.close()
            self.localFile.close()
            
            self.image = gtk.gdk.pixbuf_new_from_file(self.config_dir + '/'+str(self.cont)+'.jpg')
			
            for j in self.itemlist:
                self.titlelist = j.getElementsByTagName("title")
				#print titlelist
                self.titolo = self.titlelist[0].toxml()[7:-8]
				#url = j.attributes["linkUrl"].value
				#print url
                self.xmlurl = j.attributes["xmlURL"].value

                self.webXMLfile = urllib.urlopen(self.xmlurl)
   
                self.xmldoc2 = minidom.parse(self.webXMLfile)

                self.webXMLfile.close()
                self.description = self.xmldoc2.getElementsByTagName('description')
                self.descrizione = self.description[0].toxml()[13:-14]
				
                self.fms = self.xmldoc2.getElementsByTagName('fms')
               # print self.rtmpurl+self.fms[1].toxml()[9:-6]
              
                self.model.append([self.image,"<b>"+self.titolo.encode("UTF-8")+"</b>\n<i>"+self.descrizione.encode("UTF-8")+"</i>",self.rtmpurl+self.fms[1].toxml()[9:-6]])
                gtk.gdk.threads_leave()
            self.cont+=1
        self.combobox.set_button_sensitivity(gtk.SENSITIVITY_ON)
        self.statusbar.push(1,_("La7's recordings list: 'Cult Archive' updated"))
        
        
class Thread_youtube(threading.Thread):
    def __init__(self, model, statusbar, text, startindex, search_butt, prev_butt, next_butt):
        threading.Thread.__init__(self)
        self.model = model
        self.model.clear()
        self.statusbar = statusbar
        self.text = text
        self.startindex = startindex
        self.search_butt = search_butt
        self.prev_butt = prev_butt
        self.next_butt = next_butt
        self.contatore = 0
        
     #   self.search_butt.props.sensitive = False
        self.prev_butt.props.sensitive = False
        self.next_butt.props.sensitive = False

    def PrintVideoFeed(self,feed):
		for entry in feed.entry:
			self.PrintEntryDetails(entry)
			
    def PrintEntryDetails(self,entry):
        gtk.gdk.threads_enter()

        home = os.path.expanduser('~')
        self.config_dir = home +'/.tvplayer/youtube'

        self.imagefile = urllib.urlopen(entry.media.thumbnail[0].url)
        self.localFile = open(os.path.expanduser(self.config_dir + '/'+'image.jpg'), 'w+')
        self.localFile.write(self.imagefile.read())
        self.imagefile.close()
        self.localFile.close()
        
        self.image = gtk.gdk.pixbuf_new_from_file_at_size(self.config_dir + '/'+'image.jpg',100,80)
        try:
            replace=entry.media.description.text.replace('&','&amp;')
            descr=replace.split(' ')
        
            if len(descr)>11:
		        self.model.append([self.image,'<b>'+entry.media.title.text.replace('&','&amp;')+'</b>\n<small><i>'+' '.join(descr[0:10])+'\n'+' '.join(descr[10:20])+'...\n'+_('<b>Duration: </b>')+entry.media.duration.seconds+_(' seconds')+'</i></small>\n',entry.media.player.url])
            else:
		        self.model.append([self.image,'<b>'+entry.media.title.text.replace('&','&amp;')+'</b>\n<small><i>'+' '.join(descr[0:10])+'...\n'+_('<b>Duration: </b>')+entry.media.duration.seconds+_(' seconds')+'</i></small>\n',entry.media.player.url])
        except:
            print _("Error")
        self.contatore+=1
        if self.contatore==25:
          #  self.search_butt.props.sensitive = True
            if self.startindex!='1':
                self.prev_butt.props.sensitive = True
            self.next_butt.props.sensitive = True
        gtk.gdk.threads_leave()

    def run(self):
		yt_service = gdata.youtube.service.YouTubeService()
		query = gdata.youtube.service.YouTubeVideoQuery(startindex=self.startindex)
		query.vq = self.text
		query.orderby = 'viewCount'
		query.racy = 'include'
		feed = yt_service.YouTubeQuery(query)
		self.PrintVideoFeed(feed)
		
class Thread_youtubeDownload(threading.Thread):
    def __init__(self, url, progressbar, posizione, statusbar):
        threading.Thread.__init__(self)
        self.url = url
        self.progressbar = progressbar
        self.posizione = posizione
        self.statusbar = statusbar
	
    def avanzamento(self,blocknum, bs, size):
        gtk.gdk.threads_enter()
        self.progressbar.show()
        
        bytes = blocknum*bs
        if bytes >= size:
            self.progressbar.hide()
            print _('Video is saved')
            self.statusbar.push(1,_('Video is saved'))
        perc = (100.0 * bytes)/size
        self.progressbar.set_fraction((perc*0.01))
        self.progressbar.set_text("Downloading video "+str(int(perc))+"%")


        gtk.gdk.threads_leave()
        

    def run(self):
		urllib.urlretrieve(self.url,self.posizione,self.avanzamento)

