#!/usr/bin/env python

#Copyright 2010 tv-player team <tvplayer.staff@gmail.com>
#       
#This program is free software; you can redistribute it and/or modify
#it under the terms of the GNU Lesser General Public License as published by
#the Free Software Foundation; version 3 of the License.
#       
#This program is distributed in the hope that it will be useful,
#but WITHOUT ANY WARRANTY; without even the implied warranty of
#MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#GNU Lesser General Public License for more details.
#       
#You should have received a copy of the GNU Lesser General Public License
#along with this program; if not, write to the Free Software
#Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston,
#MA 02110-1301, USA.

from distutils.core import setup
import glob
import os
import sys


setup(name='Tv-Player',
      version='1.0.5',
      description='Web TV/Radio viewer',
      author='Tv-Player Team',
      author_email='tvplayer.staff@gmail.com',
      url='http://tvplayersite.altervista.it',
      license='LGPL v3',
      scripts=['tv-player'],
      packages=['atom', 'gdata', 'gdata/geo', 'gdata/media', 'gdata/oauth', 'gdata/tlslite', 'gdata/tlslite/integration', 'gdata/tlslite/utils', 'gdata/youtube', 'libradiotv', 'libmimms'],
      data_files=[
            ('share/applications', ['application/tvplayer.desktop']),
            ('share/doc/tvplayer', glob.glob('doc/*')),
            ('share/tvplayer/pixmaps', glob.glob('pixmaps/*.png')),
            ('share/tvplayer/pixmaps/volume_ico', glob.glob('pixmaps/volume_ico/*')),
            ('share/tvplayer/ui', glob.glob('ui/*')),
            ('share/tvplayer', ['la7.sh', 'regioni.list']) ] +
            [('share/locale/'+lang+'/LC_MESSAGES/', ['locale/'+lang+'/LC_MESSAGES/tvplayer.mo'] ) for lang in listdir('locale')]
     )
